unit DelphiAddInObj;

interface

uses
  IntegracaoDelphiSUML;


type

  { TDelphiAddInObj }

  TDelphiAddInObj = class
  public
//    EventPub: IEventPublisher;
//    function GetSelectedModel: IModel;
    class procedure ActionMenu_GenerateRegisterModelMappings;
    class procedure ActionMenu_LoadMethods;
    class procedure ActionMenu_GeneratePreview;
    class procedure ActionMenu_CodeGenerator;
    class procedure ActionMenu_XSDEditor;
    class procedure ActionMenu_InsertUseCase;
    class procedure ActionMenu_InsertClass;
    class procedure ActionMenu_EditClass;
    class procedure ActionMenu_EditUseCase;
    class procedure ActionMenu_ElementDocumentation;
    class procedure ActionMenu_UseCaseXSDsEditor;
    class procedure ActionMenu_ConvertXSDsToUseCaseXSD;
    class procedure ActionMenu_ExportDiagramClasses;
    class procedure ActionMenu_ExportPackageClasses;
    class procedure ActionMenu_ExportUseCases;
    class procedure ActionMenu_OQLV2;
    class procedure ActionMenu_CXOQLV2;

//    procedure ListOwnedClasses( piPackage : IUMLPackage ; piObjectList : TInterfaceList ; piStringList : TStringList);
//    procedure ListOwnedUseCases ( piPackage : IUMLPackage ; piObjectList : TInterfaceList ; piStringList : TStringList);

    class function GetServiceConnectionString: string;
    class function DoMenuAction(const ActionID: Integer): Integer;
//    function NotifyEvent(AEvent: EventKind): HResult; stdcall;
  end;


implementation

uses
  windows,
  InstantCode, SysUtils, Mostra_Processamento, utuStateMachine, fCodeGen, Controls, Forms,
  fModelMappingsGenerationOptions, fXSDEditor, ituDataBaseLogin, cxuSession, formMemo,
  utuMessage, uCadastroCasoDeUso, uCadastroClasse, ituServiceParameters, ituExplorerV2,
  Registry, uRTFEditor, ituXSDExplorer, ituExportUnits, ituOQLExplorerV2, Classes;

{procedure TDelphiAddInObj.NotifyUpdate(piMsg: string);
begin
  MessageDlg(piMsg, mtInformation, [mbOk], 0);
end; }

{procedure TDelphiAddInObj.ProccessUpdates;
var
  I: integer;
  lModel: IModel;
  lClass: IUMLClass;
  lAttribute: IUMLAttribute;
  lAssoc: IUMLAssociation;
  lGen: IUMLGeneralization;  
  lLog: string;

  lElementsList: TInterfaceList;
begin

  lElementsList := TInterfaceList.Create;
  try
    for I := 0 to EventPub.GetEventArgModelCount - 1 do
    begin
      lModel := EventPub.GetEventArgModelAt(I);

      if lModel.QueryInterface(IUMLClass, lClass) =  S_OK then
      begin
        if lElementsList.IndexOf(lClass) < 0 then lElementsList.Add(lClass);
      end;

      if lModel.QueryInterface(IUMLAssociation, lAssoc) =  S_OK then
      begin
        if lAssoc.GetConnectionAt(0).Participant.QueryInterface(IUMLClass, lClass) = S_OK then
        begin
          if lElementsList.IndexOf(lClass) < 0 then lElementsList.Add(lClass);
        end;
          
        if lAssoc.GetConnectionAt(1).Participant.QueryInterface(IUMLClass, lClass) = S_OK then
        begin
          if lElementsList.IndexOf(lClass) < 0 then lElementsList.Add(lClass);
        end;
      end;

      if lModel.QueryInterface(IUMLAttribute, lAttribute) =  S_OK then
      begin
        if lAttribute.Owner.QueryInterface(IUMLClass, lClass) = S_OK then
        begin
          if lElementsList.IndexOf(lClass) < 0 then lElementsList.Add(lClass);
        end;
      end;

      if lModel.QueryInterface(IUMLGeneralization, lGen) =  S_OK then
      begin
        if lGen.Child.QueryInterface(IUMLClass, lClass) = S_OK then
        begin
          if lElementsList.IndexOf(lClass) < 0 then lElementsList.Add(lClass);
        end;
      end;
    
    end;    
  
    for I := 0 to lElementsList.Count - 1 do
    begin
       lLog := lLog + '(' + IUMLClass(lElementsList.Items[I]).GetClassName + ')' + ' ' + IUMLClass(lElementsList.Items[I]).Pathname + #13#10;    
    end;
    NotifyUpdate(lLog);
    
  finally
    lElementsList.Free;
  end;

end; }

//procedure TDelphiAddInObj.ListOwnedClasses(piPackage: IUMLPackage; piObjectList: TInterfaceList; piStringList: TStringList);
//var
//  lEnum : Integer;
//  lClass: IUMLClass;
//  lPackage : IUMLPackage;
//begin
//  for lEnum := 0 to piPackage.GetOwnedElementCount - 1 do
//  begin
//    if piPackage.GetOwnedElementAt(lEnum).QueryInterface(IUMLPackage, lPackage) = S_OK then
//      ListOwnedClasses(lPackage,piObjectList,piStringList);
//  end;
//  for lEnum := 0 to piPackage.GetOwnedElementCount - 1  do
//  begin
//    if piPackage.GetOwnedElementAt(lEnum).QueryInterface(IUMLClass, lClass) = S_OK then
//    begin
//      piObjectList.Add(lClass);
//      piStringList.Add(lClass.Pathname );
//    end;
//  end;
//end;
//
//procedure TDelphiAddInObj.ListOwnedUseCases(piPackage: IUMLPackage; piObjectList: TInterfaceList; piStringList: TStringList);
//var
//  lEnum : Integer;
//  lUseCase: IUMLUseCase;
//  lPackage : IUMLPackage;
//begin
//  for lEnum := 0 to piPackage.GetOwnedElementCount - 1 do
//  begin
//    if piPackage.GetOwnedElementAt(lEnum).QueryInterface(IUMLPackage, lPackage) = S_OK then
//      ListOwnedUseCases(lPackage,piObjectList,piStringList);
//  end;
//  for lEnum := 0 to piPackage.GetOwnedElementCount - 1  do
//  begin
//    if piPackage.GetOwnedElementAt(lEnum).QueryInterface(IUMLUseCase, lUseCase) = S_OK then
//    begin
//      piObjectList.Add(lUseCase);
//      piStringList.Add(lUseCase.Pathname );
//    end;
//  end;
//end;

class function TDelphiAddInObj.GetServiceConnectionString: string;
var lServiceParamDialog: TitServiceParameters;
    lReg: TRegistry;
begin
  lServiceParamDialog := TitServiceParameters.Create(nil);
  try
    lReg := TRegistry.Create;
    try
      lReg.RootKey := HKEY_CURRENT_USER;
//      lReg.OpenKey(cPROJECT_SAVE_OPTIONS_PATH + ExtractFileName(StarUMLApp.ProjectManager.FileName) + '\Service', true);

      if lReg.ValueExists('SERVICE_SERVERNAME') then lServiceParamDialog.ServerName := lReg.ReadString('SERVICE_SERVERNAME');
      if lReg.ValueExists('SERVICE_PORTNUMBER') then lServiceParamDialog.PortNumber := lReg.ReadInteger('SERVICE_PORTNUMBER');
      if lReg.ValueExists('SERVICE_SYSTEMCODE') then lServiceParamDialog.SystemCode := lReg.ReadInteger('SERVICE_SYSTEMCODE');
      if lReg.ValueExists('SERVICE_USERNAME')   then lServiceParamDialog.UserName := lReg.ReadString('SERVICE_USERNAME');
      if lReg.ValueExists('SERVICE_PASSWORD')   then lServiceParamDialog.Password := lReg.ReadString('SERVICE_PASSWORD');

      //if lServiceParamDialog.ShowModal = mrok then
      //begin
      //  lReg.WriteString('SERVICE_SERVERNAME', lServiceParamDialog.ServerName);
      //  lReg.WriteInteger('SERVICE_PORTNUMBER', lServiceParamDialog.PortNumber);
      //  lReg.WriteInteger('SERVICE_SYSTEMCODE', lServiceParamDialog.SystemCode);
      //  lReg.WriteString('SERVICE_USERNAME', lServiceParamDialog.UserName);
      //  lReg.WriteString('SERVICE_PASSWORD', lServiceParamDialog.Password);
      //
      //  StarUMLApp.ProjectManager.Project.SetTaggedValueAsInteger('DBMappings', 'ProjectMap', 'SystemCode', lServiceParamDialog.SystemCode);
      //  StarUMLApp.ProjectManager.Project.SetTaggedValueAsInteger('DBMappings', 'ProjectMap', 'PortNumber', lServiceParamDialog.PortNumber);
      //
      //  result := format('ServerName=%s;PortNumber=%d;SystemCode=%d;UserName=%s;Password=%s;',
      //                   [lServiceParamDialog.ServerName, lServiceParamDialog.PortNumber,
      //                    lServiceParamDialog.SystemCode, lServiceParamDialog.UserName,
      //                    lServiceParamDialog.Password]);
      //end
      //else
      //  result := '';
    finally
      lReg.free;
    end;
  finally
    lServiceParamDialog.Free;
  end;

end;

class function TDelphiAddInObj.DoMenuAction(const ActionID: Integer): Integer;
begin
  try
    Result := S_OK;
    case ActionID of
      1: ActionMenu_GenerateRegisterModelMappings;
      2: ActionMenu_GeneratePreview;
      3: ActionMenu_LoadMethods;
      6: ActionMenu_CodeGenerator;
      7: ActionMenu_XSDEditor;
      8: ActionMenu_InsertUseCase;
      9: ActionMenu_InsertClass;
      10: ActionMenu_EditClass;
      11: ActionMenu_EditUseCase;
      12: ActionMenu_ElementDocumentation;
      13: ActionMenu_UseCaseXSDsEditor;
      14: ActionMenu_ConvertXSDsToUseCaseXSD;
      15: ActionMenu_ExportDiagramClasses;
      16: ActionMenu_ExportPackageClasses;
      17: ActionMenu_ExportUseCases;
      18: ActionMenu_OQLV2;
      19: ActionMenu_CXOQLV2;
    end;
  except
    on E: Exception do
    begin
      Application.MessageBox(PAnsiChar(e.Message), 'Staruml', MB_ICONERROR);
      raise;
    end;
  end;
end;

class procedure TDelphiAddInObj.ActionMenu_GenerateRegisterModelMappings;
var lsResult: string;
    lUtilitario: TUtil;
    lProgress: TFShowProgress;
    lsModelMappingsFileName, lsModelMappingsPath: string;
    lModelMappingsOptionsForm: TModelMappingsGenerationOptions;
    lModelMappingsOptions: TModelMappingsOptions;
    lMetaModelGenOpt: TMetaModelGenerationOptions;
begin
  lsModelMappingsFileName := '';
  lsModelMappingsPath := '';
  lMetaModelGenOpt.SilentMode := false;
  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
  lMetaModelGenOpt.CheckDBTableNameLength := true;

  /////////////////////////////////////////////////////////////////////////
{  lModelMappingsOptionsForm := TModelMappingsGenerationOptions.Create(nil);
  try
    if lModelMappingsOptionsForm.ShowModal = mrok then
    begin
      lsModelMappingsPath := lModelMappingsOptionsForm.dlbDirectory.Directory;
      lsModelMappingsFileName := lModelMappingsOptionsForm.edtFileName.Text;
      lModelMappingsOptions.IgnoreXSDSchema := lModelMappingsOptionsForm.ckbIgnoreXSD.Checked;
      lModelMappingsOptions.FileName := IncludeTrailingBackslash(trim(lsModelMappingsPath)) +  lsModelMappingsFileName;
      if lModelMappingsOptionsForm.rdObjectPascal.Checked
        then lModelMappingsOptions.TargetLanguage := 'O'
        else if lModelMappingsOptionsForm.rdCSharp.Checked
          then lModelMappingsOptions.TargetLanguage := 'C'
          else lModelMappingsOptions.TargetLanguage := 'J';
    end
    else
      lModelMappingsOptions.FileName := '';
  finally
    lModelMappingsOptionsForm.Free;
  end;
}
  lModelMappingsOptions.TargetLanguage := 'O';
  lModelMappingsOptions.FileName := 'teste.pas';

  if lModelMappingsOptions.FileName <> '' then
  begin
    lProgress := TFShowProgressForm.create('Creating Meta Model...');
    try                     
      lUtilitario := TUtil.Create;
      try
        if lModelMappingsOptions.TargetLanguage = 'O' then
        begin
          lsResult := lUtilitario.AlimentarMetamodel(lMetaModelGenOpt, lProgress);
          lUtilitario.GerarUnitRegisterModelMappings(lModelMappingsOptions, lProgress);
        end
        else if lModelMappingsOptions.TargetLanguage = 'C' then
        begin
          lsResult := lUtilitario.AlimentarMetamodel(lMetaModelGenOpt, lProgress);
          lUtilitario.GerarUnitRegisterModelMappings_CSharp(lModelMappingsOptions, lProgress);
        end
        else
        begin
          lsResult := lUtilitario.AlimentarMetamodel(lMetaModelGenOpt, lProgress);
          lUtilitario.GerarUnitRegisterModelMappings_Java(lModelMappingsOptions, lProgress);
        end;
      finally
        lUtilitario.Free;
      end;
             
      application.MessageBox(PAnsiChar('File ' + lModelMappingsOptions.FileName + ' was generated.'), 'Staruml', MB_OK + MB_ICONINFORMATION);
    finally
      lProgress.Free;
    end;
  end;
end;

class procedure TDelphiAddInObj.ActionMenu_LoadMethods;
var lsResult: string;
    lUtilitario: TUtil;
    lMetaModelGenOpt: TMetaModelGenerationOptions;
begin
  lMetaModelGenOpt.SilentMode := false;
  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
  lMetaModelGenOpt.CheckDBTableNameLength := true;

//  lUtilitario := TUtil.Create(StarUMLApp);
//  try
////        lsResult := lUtilitario.AlimentarMetamodel(StarUMLApp);
//    if (MessageDlg('This option will overwrite class methods. Continue?', mtConfirmation, [mbYes, mbNo], 0) = mryes) then
//    begin
//      lsResult := lUtilitario.CarregaMetodo(StarUMLApp);
//      Application.MessageBox(PAnsiChar(lsResult), 'Staruml');
//    end;
//  finally
//    lUtilitario.free;
//  end;

end;

class procedure TDelphiAddInObj.ActionMenu_InsertClass;
var lCadClasse: TCadastroClasse;
    lConnString: string;
//    lModel: IModel;
//    lUMLPackageAux: IUMLPackage;
begin
  //lCadClasse := nil;
  //lConnString := GetServiceConnectionString;
  //if lConnString <> '' then
  //begin
  //  lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //  try
  //    if lModel.QueryInterface(IUMLPackage, lUMLPackageAux) = S_OK then
  //    begin
  //      lCadClasse := TCadastroClasse.Create(nil, lConnString);
  //      lCadClasse.FStarUMLAPP := StarUMLApp;
  //      lCadClasse.ClassPackage := lModel as IUMLPackage;
  //    end
  //    else
  //    begin
  //      lCadClasse := TCadastroClasse.Create(nil, lConnString);
  //      lCadClasse.FStarUMLAPP := StarUMLApp;
  //    end;
  //    if lCadClasse.ShowModal = mrok then
  //      StarUMLApp.SelectInModelExplorer(lCadClasse.UMLClass);
  //  finally
  //    if assigned(lCadClasse) then lCadClasse.Free;
  //  end;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_CodeGenerator;
var lUtilitario: TUtil;
    lCodeGen: TCodeGen;
    lMetaModelGenOpt: TMetaModelGenerationOptions;
begin
  lMetaModelGenOpt.SilentMode := false;
  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
  lMetaModelGenOpt.CheckDBTableNameLength := true;
  
  lCodeGen := TCodeGen.Create(nil);
  //Screen.Cursor := crHourGlass;
  //try
  //  lUtilitario := TUtil.Create(StarUMLApp);
  //  try
  //    lUtilitario.AlimentarMetamodel(StarUMLApp, lMetaModelGenOpt, nil);
  //    lCodeGen.Util := lUtilitario;
  //    lCodeGen.ShowModal;
  //  finally
  //    lUtilitario.Free;
  //  end;
  //finally
  //  Screen.Cursor := crDefault;
  //  lCodeGen.Free;
  //end;
end;


class procedure TDelphiAddInObj.ActionMenu_ConvertXSDsToUseCaseXSD;
var lsResult: string;
    lUtilitario: TUtil;
    lProgress: TFShowProgress;
    lsModelMappingsFileName, lsModelMappingsPath: string;
    lModelMappingsOptions: TModelMappingsOptions;
    lMetaModelGenOpt: TMetaModelGenerationOptions;
    lFileStream:  TFileStream;
    lStringStream: TStringStream;
    lOld, lNew: string;
begin
  lsModelMappingsFileName := '';
  lsModelMappingsPath := '';
  lMetaModelGenOpt.SilentMode := false;
  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
  lMetaModelGenOpt.CheckDBTableNameLength := true;

  /////////////////////////////////////////////////////////////////////////
//  lUtilitario := TUtil.Create(StarUMLApp);
  try
    if FileExists(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsOld.txt') then
      if not DeleteFile(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsOld.txt') then
        Raise Exception.Create('Could not delete file ' + IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsOld.txt');

    lsModelMappingsPath := IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP'));
    lsModelMappingsFileName :=  'ConexoTempModelMappingsOld.txt';
    lModelMappingsOptions.IgnoreXSDSchema := false;
    lModelMappingsOptions.FileName := IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsOld.txt';

    if lModelMappingsOptions.FileName <> '' then
    begin
      lProgress := TFShowProgressForm.create('Creating Meta Model...');
      try
//        lsResult := lUtilitario.AlimentarMetamodel(StarUMLApp, lMetaModelGenOpt,lProgress);
//        lUtilitario.GerarUnitRegisterModelMappings(lModelMappingsOptions, lProgress);
      finally
        lProgress.Free;
      end;
    end;
  finally
    lUtilitario.Free;
  end;

  //lUtilitario := TUtil.Create(StarUMLApp);
  //try
  //  lProgress := TFShowProgressForm.create('');
  //  try
  //    lUtilitario.ConvertXSDsToUseCaseXSD(lProgress);
  //  finally
  //    lProgress.Free;
  //  end;
  //finally
  //  lUtilitario.Free;
  //end;

//  lUtilitario := TUtil.Create(StarUMLApp);
  try
    if FileExists(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsNew.txt') then
      if not DeleteFile(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsNew.txt') then
        Raise Exception.Create('Could not delete file ' + IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsNew.txt');

    lsModelMappingsPath := IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP'));
    lsModelMappingsFileName := 'ConexoTempModelMappingsNew.txt';
    lModelMappingsOptions.IgnoreXSDSchema := false;
    lModelMappingsOptions.FileName := IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsNew.txt';

    if lModelMappingsOptions.FileName <> '' then
    begin
      lProgress := TFShowProgressForm.create('Creating Meta Model...');
      try
//        lsResult := lUtilitario.AlimentarMetamodel(StarUMLApp, lMetaModelGenOpt,lProgress);
//        lUtilitario.GerarUnitRegisterModelMappings(lModelMappingsOptions, lProgress);
      finally
        lProgress.Free;
      end;
    end;
  finally
    lUtilitario.Free;
  end;

  lFileStream := TFileStream.Create(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsOld.txt', fmOpenRead);
  try
    lStringStream := TStringStream.Create('');
    try
      lStringStream.CopyFrom(lFileStream, 0);
      lOld := lStringStream.DataString;
    finally
      lStringStream.free;
    end;
  finally
    lFileStream.free;
  end;

  lFileStream := TFileStream.Create(IncludeTrailingPathDelimiter(GetEnvironmentVariable('TEMP')) + 'ConexoTempModelMappingsNew.txt', fmOpenRead);
  try
    lStringStream := TStringStream.Create('');
    try
      lStringStream.CopyFrom(lFileStream, 0);
      lNew := lStringStream.DataString;
    finally
      lStringStream.free;
    end;
  finally
    lFileStream.free;
  end;

  if lNew = lOld then
  begin
//    Showmessage('Converso realizada com sucesso.');
  end
  else
//    Showmessage('Erro ao realizar a converso.');
end;

class procedure TDelphiAddInObj.ActionMenu_CXOQLV2;
var
  lOQLExplorer: TOQLExplorerV2;
begin
  lOQLExplorer := TOQLExplorerV2.Create(nil);
  lOQLExplorer.Show;
end;

class procedure TDelphiAddInObj.ActionMenu_EditClass;
var lCadClasse: TCadastroClasse;
    lConnString: string;

//    lModel: IModel;

//    lUMLClassAux: IUMLClass;
begin
  // lCadClasse := nil;
  //lConnString := GetServiceConnectionString;
  //if lConnString <> '' then
  //begin
  //  lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //
  //    if lModel.QueryInterface(IUMLClass, lUMLClassAux) = S_OK then
  //    begin
  //      lUMLClassAux := lModel as IUMLClass;
  //      try
  //        lCadClasse := TCadastroClasse.Create(nil, lConnString, lUMLClassAux);
  //        lCadClasse.FStarUMLAPP := StarUMLApp;
  //        if lCadClasse.ShowModal = mrok then
  //          StarUMLApp.SelectInModelExplorer(lCadClasse.UMLClass);
  //      finally
  //        if assigned(lCadClasse) then lCadClasse.Free;
  //      end;
  //    end
  //    else
  //      raise Exception.Create('This option is avaliable only for classes.');
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_EditUseCase;
//var lCadCasoDeUso: TCadastroCasoDeUso;
//    lConnString: string;
//
//    lModel: IModel;
//
//    lUMLUseCaseAux: IUMLUseCase;
begin
  //lCadCasoDeUso := nil;
  //lConnString := GetServiceConnectionString;
  //if lConnString <> '' then
  //begin
  //  lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //  try
  //    if lModel.QueryInterface(IUMLUsecase, lUMLUseCaseAux) = S_OK then
  //    begin
  //      lUMLUseCaseAux := lModel as IUMLUsecase;
  //      lCadCasoDeUso := TCadastroCasoDeUso.Create(nil, lConnString, lUMLUseCaseAux);
  //      lCadCasoDeUso.FStarUMLAPP := StarUMLApp;
  //    end
  //    else
  //      raise exception.Create('This option is only avaliable for Usecases.');
  //
  //    if lCadCasoDeUso.ShowModal = mrok then
  //      StarUMLApp.SelectInModelExplorer(lCadCasoDeUso.GetUseCase);
  //  finally
  //    if assigned(lCadCasoDeUso) then lCadCasoDeUso.Free;
  //  end;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_GeneratePreview;
//var lPreview: TPreviewClassCode;
//    lUtilitario: TUtil;
//    lModel: IModel;
//    lUMLClasAux: IUMLClass;
//    lUMLAssociationAux: IUMLAssociation;
//    lMetaModelGenOpt: TMetaModelGenerationOptions;
begin
//  lMetaModelGenOpt.SilentMode := false;
//  lMetaModelGenOpt.CheckDBAttributeNameLength := true;
//  lMetaModelGenOpt.CheckDBTableNameLength := true;
//
//  lUtilitario := TUtil.Create(StarUMLApp);
//  try
//    lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
//    if lModel.QueryInterface(IUMLClass, lUMLClasAux) = S_OK then
//    begin
//      lUtilitario.AlimentarMetamodel(StarUMLApp, lMetaModelGenOpt, nil);
//      lPreview := TPreviewClassCode.Create(nil);
//      try
////        inserir preview para oracle
//        lPreview.mem_ClassPascal.Lines.Text := lUtilitario.GerarClassPreview_Pascal(lModel as IUMLClass);
//        lPreview.mem_ClassCSharp.Lines.Text := lUtilitario.GerarClassPreview_CSharp(lModel as IUMLClass);
//        lPreview.mem_ClassJava.Lines.Text := lUtilitario.GerarClassPreview_Java(lModel as IUMLClass);
//        lPreview.mem_ClassSQL.Lines.Text := lUtilitario.GerarSQLPreview(lModel);
//        lPreview.mem_ClassOracle.Lines.Text := lUtilitario.GerarSQLPreview(lModel, dbvOracle);
//        lPreview.ShowModal;
//      finally
//        FreeAndNil(lPreview);
//      end;
//    end
//    else
//      if lModel.QueryInterface(IUMLAssociation, lUMLAssociationAux) = S_OK then
//      begin
//        lUtilitario.AlimentarMetamodel(StarUMLApp, lMetaModelGenOpt, nil);
//        lPreview := TPreviewClassCode.Create(nil);
//        try
//          lPreview.mem_ClassSQL.Lines.Text := lUtilitario.GerarSQLPreview(lModel);
//          lPreview.mem_ClassOracle.Lines.Text := lUtilitario.GerarSQLPreview(lModel, dbvOracle);
//          lPreview.ShowModal;
//        finally
//          FreeAndNil(lPreview);
//        end;
//      end
//      else
//        raise Exception.Create('This option is avaliable only for classes and associations between classes.');
//  finally
//    freeandnil(lUtilitario);
//  end;
end;

class procedure TDelphiAddInObj.ActionMenu_OQLV2;
//var form: TDLLDialog;
begin
//  form := TDLLDialog.Create(nil);
//  form.show;
  if not assigned(ExplorerV2) then
  begin
    Application.CreateForm(TExplorerV2, ExplorerV2);
  end;
  ExplorerV2.Show;
end;

class procedure TDelphiAddInObj.ActionMenu_ExportDiagramClasses;
var
  lEnum : Integer;
  listaStrings : TStringList;
  listaObjetos : TInterfaceList;
//  lClass: IUMLClass;  
  lForm : TExportUnits;
begin
  //listaStrings := TStringList.Create;
  //listaObjetos := TInterfaceList.Create;
  //try
  //  for lEnum := 0 to StarUMLApp.SelectionManager.GetSelectedViewCount - 1  do
  //  begin
  //    if StarUMLApp.SelectionManager.GetSelectedViewAt(lenum).Model.QueryInterface(IUMLClass, lClass) = S_OK then
  //    begin
  //      listaObjetos.Add(lClass);
  //      listaStrings.Add(lClass.Pathname );
  //    end;
  //  end;
  //
  //  lForm := TExportUnits.Create(nil);
  //  lForm.Position := poScreenCenter;
  //  Screen.Cursor := crHourGlass;
  //  try
  //    for lEnum := 0 to listaStrings.Count - 1 do
  //    begin
  //      lForm.lstUsecases.AddItem(listaStrings.Strings[lEnum],nil );
  //    end;
  //    lForm.lstUsecases.SelectAll;
  //    lForm.ShowModal;  
  //  finally
  //    Screen.Cursor := crDefault;
  //    lForm.Free;
  //  end;
  //
  //  finally
  //  listaStrings.Free;
  //  listaObjetos.Free;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_UseCaseXSDsEditor;
var lXSDExplorer: TXSDExplorer;
begin
//  lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //if lModel.GetMetaClass.IsKindOf('UMLUseCase') then
  //begin
  //  lXSDExplorer := TXSDExplorer.Create(nil, StarUMLApp, lModel as IUMLUseCase);
  //  try
  //    lXSDExplorer.ShowModal;
  //  finally
  //    lXSDExplorer.free;
  //  end;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_ElementDocumentation;
//var lModel: IModel;
//    lRTFEditor: TRTFEditor;
begin
  //lRTFEditor := nil;
  //lModel := GetSelectedModel;
  //if assigned(lModel) then
  //begin
  //  try
  //    lRTFEditor := TRTFEditor.Create(nil);
  //    lRTFEditor.DocWithRTFInformation := lModel.Documentation;
  //    lRTFEditor.Caption := lModel.Pathname;
  //    if lRTFEditor.ShowModal = mrok then
  //      lModel.Documentation := lRTFEditor.DocWithRTFInformation;
  //  finally
  //    lRTFEditor.free;
  //  end;
  //end
  //else
  //  raise exception.Create('This option is only avaliable for Usecases.');
end;

class procedure TDelphiAddInObj.ActionMenu_ExportPackageClasses;
//var
//  listaStrings : TStringList;
//  listaObjetos : TInterfaceList;
//  lPackage : IUMLPackage;
//  lForm : TExportUnits;
//  lEnum : Integer;
begin
  //if StarUMLApp.SelectionManager.GetSelectedModelAt(0).QueryInterface(IUMLPackage, lPackage) = S_OK then
  //begin
  //  listaStrings := TStringList.Create;
  //  listaObjetos := TInterfaceList.Create;
  //  try
  //    ListOwnedClasses(lPackage,listaObjetos,listaStrings);
  //
  //    lForm := TExportUnits.Create(nil);
  //    lForm.Position := poScreenCenter;
  //    Screen.Cursor := crHourGlass;
  //    try
  //      for lEnum := 0 to listaStrings.Count - 1 do
  //      begin
  //        lForm.lstUsecases.AddItem(listaStrings.Strings[lEnum],nil );
  //      end;
  //      lForm.lstUsecases.SelectAll;
  //      lForm.ShowModal;  
  //    finally
  //      Screen.Cursor := crDefault;
  //      lForm.Free;
  //    end;
  //
  //  finally
  //    listaStrings.Free;
  //    listaObjetos.Free;
  //  end;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_ExportUseCases;
//var
//  listaStrings : TStringList;
//  listaObjetos : TInterfaceList;
//  lPackage : IUMLPackage;
//  lUseCase: IUMLUseCase;
//  lForm : TExportUnits;
//  lEnum : Integer;
begin
  //listaStrings := TStringList.Create;
  //listaObjetos := TInterfaceList.Create;
  //try
  //  if StarUMLApp.SelectionManager.GetSelectedModelAt(0).QueryInterface(IUMLPackage, lPackage) = S_OK then
  //  begin
  //    ListOwnedUseCases(lPackage,listaObjetos,listaStrings);
  //  end
  //  else
  //  begin
  //    if StarUMLApp.SelectionManager.GetSelectedModelAt(0).QueryInterface(IUMLUseCase, lUseCase) = S_OK then
  //    begin
  //      listaObjetos.Add(lUseCase);
  //      listaStrings.Add(lUseCase.Pathname );
  //    end;
  //  end;
  //
  //  lForm := TExportUnits.Create(nil);
  //  lForm.Position := poScreenCenter;
  //  Screen.Cursor := crHourGlass;
  //  try
  //    for lEnum := 0 to listaStrings.Count - 1 do
  //    begin
  //      lForm.lstUsecases.AddItem(listaStrings.Strings[lEnum],nil );
  //    end;
  //    lForm.lstUsecases.SelectAll;
  //    lForm.ShowModal;  
  //  finally
  //    Screen.Cursor := crDefault;
  //    lForm.Free;
  //  end;
  //
  //finally
  //  listaStrings.Free;
  //  listaObjetos.Free;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_InsertUseCase;
//var lCadCasoDeUso: TCadastroCasoDeUso;
//    lConnString: string;
//
//    lModel: IModel;
//
//    lUMLPackageAux: IUMLPackage;
begin
  //lCadCasoDeUso := nil;
  //lConnString := GetServiceConnectionString;
  //if lConnString <> '' then
  //begin
  //  lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //  try
  //    if lModel.QueryInterface(IUMLPackage, lUMLPackageAux) = S_OK then
  //    begin
  //      lCadCasoDeUso := TCadastroCasoDeUso.Create(nil, lConnString);
  //      lCadCasoDeUso.FStarUMLAPP := StarUMLApp;
  //      lCadCasoDeUso.UseCasePackage := lModel as IUMLPackage;
  //    end
  //    else
  //    begin
  //      lCadCasoDeUso := TCadastroCasoDeUso.Create(nil, lConnString);
  //      lCadCasoDeUso.FStarUMLAPP := StarUMLApp;
  //    end;
  //
  //    if lCadCasoDeUso.ShowModal = mrok then
  //      StarUMLApp.SelectInModelExplorer(lCadCasoDeUso.GetUseCase);
  //  finally
  //    if assigned(lCadCasoDeUso) then lCadCasoDeUso.Free;
  //  end;
  //end;
end;

class procedure TDelphiAddInObj.ActionMenu_XSDEditor;
//var
//    lModel: IModel;
//    lUMLTransitionAux: IUMLTransition;
//    lXSDEditor: TXSDEdit;
begin
  //lModel := StarUMLApp.SelectionManager.GetSelectedModelAt(0);
  //if lModel.QueryInterface(IUMLTransition, lUMLTransitionAux) = S_OK then
  //begin
  //  lXSDEditor := TXSDEdit.Create(nil);
  //  try
  //    lXSDEditor.StarUMLAPP := self.StarUMLApp;
  //    lXSDEditor.Transition := lModel as IUMLTransition;
  //    lXSDEditor.ShowModal;
  //  except
  //    FreeAndNil(lXSDEditor);
  //  end;
  //end
  //else
  //  raise Exception.Create('This option is avaliable only for transitions.');
  //
end;

// TDelphiAddInObj
////////////////////////////////////////////////////////////////////////////////

end.
